' @(#)72  1.7  src/hc/client/collectors/C/vbs/groups.vbs, hc.collectors.win, scmweb, 060928a  9/28/06  07:42:06
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'------------------------------------------------------------

Const ADS_GROUP_TYPE_BUILTIN = &H1
Const ADS_GROUP_TYPE_GLOBAL_GROUP = &h2
Const ADS_GROUP_TYPE_LOCAL_GROUP = &h4
Const ADS_GROUP_TYPE_UNIVERSAL_GROUP = &h8
Const ADS_GROUP_TYPE_SECURITY_ENABLED = &h80000000

Const GROUP_SCOPE_LOCAL = "local"
Const GROUP_SCOPE_GLOBAL = "global"
Const GROUP_SCOPE_UNIVERSAL = "universal"
Const GROUP_SCOPE_UNKNOWN = "unknown"
Const GROUP_SCOPE_BUILTIN = "builtin"
Const GROUP_TYPE_SECURITY = "security"
Const GROUP_TYPE_DISTRIBUTION = "distribution"
Const GROUP_TYPE_UNKNOWN = NULL

Const ROLE_STANDALONE_WST = 0
Const ROLE_MEMBER_WST = 1
Const ROLE_STANDALONE_SVR = 2
Const ROLE_MEMBER_SVR = 3
Const ROLE_BACKUP_DC = 4
Const ROLE_PRIMARY_DC = 5

On Error Resume Next


'------------------------------------------------------------
' Main
'------------------------------------------------------------
root = NULL
domain = NULL
isActiveDirectory = FALSE

Set wmi = GetObject("winmgmts:\\.\root\cimv2")
Set compList = wmi.ExecQuery("Select DomainRole, Name, Domain from Win32_ComputerSystem")
For Each computer in compList
	computerRole = computer.DomainRole
	computerName = computer.Name
	'WScript.Echo computerRole
Next
' Decide which way of resolving use on this machine
If (computerRole = ROLE_BACKUP_DC) OR (computerRole = ROLE_PRIMARY_DC) Then
	'Active Directory
	Set root = GetObject("LDAP://RootDSE")
	Set domain = GetObject("LDAP://" & root.Get("dnsHostName"))
	If (Not IsNull(root)) AND (Not IsNull(domain)) Then
		isActiveDirectory = TRUE
		Call ListForActiveDirectory(domain)
	Else
		WScript.StdErr.Write "[Error] Domain controller is not responding."
		WScript.Quit(-1)
	End If
Else
	'Local computer
	isActiveDirectory = FALSE
    If ( (computerRole = ROLE_STANDALONE_WST) OR (computerRole = ROLE_STANDALONE_SVR) ) Then
		Call ListForLocalComputer(computerName, computerRole, "")
	Else
		Call ListForLocalComputer(computerName, computerRole, "")
	End If

	
End If

WScript.Quit(0)

'------------------------------------------------------------
' Lists groups and members for local computer, 
' ie. non-domain controller station
'------------------------------------------------------------
Sub ListForLocalComputer(computerName, computerRole, querySuffix)
    ' Prepare WMI
	Set rss = GetObject("WinNT://" & ".")
	
	rss.Filter = Array("group")
    For Each rsItem in rss
        Set obj = CreateObject("Scripting.Dictionary") 
        groupSid = ConvertSidToString(rsItem.objectSid)
		
		obj.Add "cn", rsItem.Name
        obj.Add "objectSid", groupSid
        obj.Add "groupType", rsItem.groupType
        obj.Add "description", rsItem.description
        obj.Add "distinguishedName", rsItem.Name  

        DisplayGroupInfo obj
		
        For Each asItem In rsItem.Members
			DisplayMemberInfo asItem, groupSid
        Next
            
        WScript.Echo  
    Next

End Sub

'------------------------------------------------------------
' Lists objects for Domain Controller station
'------------------------------------------------------------
Sub ListForActiveDirectory(domain)
    ' Prepare ADODB
    Set con = CreateObject("ADODB.Connection")
    Set cmd = CreateObject("ADODB.Command")
    con.Provider = "ADsDSOObject"
    con.Open "Active Directory Provider"
    cmd.ActiveConnection = con
	cmd.Properties("Cache Results") = False
	
	' First: containers in current domain
	domain.Filter = Array("container","builtinDomain")
	For Each objContainer In domain

		' Second: groups in container
		objContainer.Filter = Array("group")
		For Each objGroup In objContainer

			' Prepare group object to be displayed
			Set groupDict = CreateObject("Scripting.Dictionary") 
			PrepareObject groupDict, objGroup
			DisplayGroupInfo groupDict
		
			groupSid = ConvertSidToString(objGroup.objectSid)
		
			' Third.One: members of a group
			For Each objMember In objGroup.Members
				DisplayMemberInfo objMember, groupSid
			Next
			
			' Third.Two: primary group members
			objGroup.GetInfoEx Array("primaryGroupToken"), 0
			
			sADsPath = "<" & domain.ADsPath & ">"
			strAttributes = "distinguishedName,sAMAccountName,objectCategory,objectSid" 
			strFilter = "((primaryGroupID=" & objGroup.Get("primaryGroupToken") & "))"
			strQuery = sADsPath & ";" & strFilter & ";" & strAttributes & ";subtree" 
			cmd.CommandText = strQuery 
			Set rsMembers = cmd.Execute 

			Do Until rsMembers.EOF 
				mm = NULL
				Set mm = GetObject("LDAP://" & rsMembers.Fields("distinguishedName").Value )
				DisplayMemberInfo mm, groupSid
				rsMembers.MoveNext 
			Loop
		
			WScript.Echo 
			
			Set groupDict = Nothing
			Set groupSid = Nothing
			Set rsMembers = Nothing
			Set mm = Nothing
		Next

	Next
End Sub

'------------------------------------------------------------
' Returns domain name based on given SID 
'------------------------------------------------------------
Function GetDomainNameFromSid(objectSid) 
	Set wmiService = GetObject("winmgmts:\\.\root\cimv2")  
	arr = Split(objectSid, "-")
	ReDim Preserve arr(UBound(arr) - 1)
	domainSid = Join(arr, "-")
	Set obj = wmiService.Get("Win32_SID.SID='" & domainSid & "'")  
	GetDomainNameFromSid = obj.ReferencedDomainName
End Function

'------------------------------------------------------------
' Returns name based on given SID
'------------------------------------------------------------
Function GetNameFromSid(sid) 
	strComputer = "."
	Set wmiService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")  
	Set obj = wmiService.Get("Win32_SID.SID='" & sid & "'")  
	strName = obj.AccountName  
	strDomain = obj.ReferencedDomainName 
	GetNameFromSid = strDomain & "\" & strName
End Function

'------------------------------------------------------------
' Displays information about group member
'------------------------------------------------------------
Sub DisplayMemberInfo(member, groupSid) 
	On Error Resume Next 
    
	mType = NULL
	mDecSid = NULL
	name = NULL

	mType = LCase(member.Class)
	mObjSid = member.Get("objectSid")

	If Err.Number <> 0 Then
		name = member.Get("name")
	Else 
		mDecSid = ConvertSidToString( mObjSid )
		name = GetNameFromSid( mDecSid )
		If (name="\") Then
		    If (isActiveDirectory) Then
				name = GetDomainNameFromSid( mDecSid ) & "\" & member.sAMAccountName
			Else
				name = mDecSid
				mType = "unknown"
			End If
		End If
	End If
	Err.Clear
	
	WScript.Echo
    WScript.Echo "[member]"
	Wscript.Echo "name         = " & name
    WScript.Echo "itemType     = " & mType
    WScript.Echo "itemSID      = " & mDecSid
    WScript.Echo "parentSID    = " & groupSid

	Set mType = Nothing
	Set mName = Nothing
	Set mDecSid = Nothing
    
End Sub


'------------------------------------------------------------
' Displays group scope
'------------------------------------------------------------
Function GetGroupScope(val)
	scope = GROUP_SCOPE_UNKNOWN

    If val AND ADS_GROUP_TYPE_LOCAL_GROUP Then 
        scope = GROUP_SCOPE_LOCAL
    ElseIf val AND ADS_GROUP_TYPE_GLOBAL_GROUP Then
        scope = GROUP_SCOPE_GLOBAL
    ElseIf val And ADS_GROUP_TYPE_UNIVERSAL_GROUP Then
        scope = GROUP_SCOPE_UNIVERSAL
    End If
	
	If val AND ADS_GROUP_TYPE_BUILTIN Then
		If scope = GROUP_SCOPE_UNKNOWN Then 
			scope = GROUP_SCOPE_BUILTIN
		Else 
			scope = scope & " " & GROUP_SCOPE_BUILTIN
		End If
	End If

	GetGroupScope = scope
	
End Function


'------------------------------------------------------------
' Transforms record object into simple hashmap. Input 'record'
' parameter type depends on platform and workstation type
'------------------------------------------------------------
Sub PrepareObject(obj, record)
    
	If (TypeName(record) = "Object") Then
        obj.Add "cn", record.cn
        obj.Add "objectSid", ConvertSidToString( record.objectSid )
        obj.Add "groupType", record.groupType
        obj.Add "description", record.description
        obj.Add "distinguishedName", record.distinguishedName 
        obj.Add "primaryGroupToken", record.primaryGroupToken  
        
    ElseIf ( (TypeName(record) = "SWbemObjectEx") OR (TypeName(record) = "ISWbemObject") ) Then
		' ISWbemObject for Windows 2000
		' SWbemObjectEx for Windows XP, 2003 R2
        obj.Add "cn", record.Properties_.Item("Name").Value
        obj.Add "objectSid", record.Properties_.Item("SID").Value
        obj.Add "groupType", ADS_GROUP_TYPE_LOCAL_GROUP
        obj.Add "description", record.Properties_.Item("Description").Value
        obj.Add "distinguishedName", record.Properties_.Item("Name").Value  
       
    End If

End Sub

 
'------------------------------------------------------------
' Displays group information nodes
'------------------------------------------------------------
Sub DisplayGroupInfo(object)
    WScript.Echo "[group]"
    
    ' name
    Wscript.Echo "name         = " & GetNameFromSid( object.Item("objectSid") ) 
	
    ' scope
    val = object.Item("groupType")
    groupScope = NULL
    groupScope = GetGroupScope(val)
    WScript.Echo "scope        = " & groupScope
    
    groupType = NULL
    If isActiveDirectory Then
        If val And ADS_GROUP_TYPE_SECURITY_ENABLED Then
            groupType = GROUP_TYPE_SECURITY
        Else
            groupType = GROUP_TYPE_DISTRIBUTION
        End If
    End If
    WScript.Echo "type         = " & groupType
  
    ' comment   
    comment = NULL
    descr =  object.Item("description")
    If not IsNull(descr) Then
		comment = descr
    End If
    WScript.Echo "comment      = " & comment

    ' sid
    decSid = NULL
    decSid = object.Item("objectSid")
    WScript.Echo "groupSID     = " & decSid

    ' domain
    domainName = NULL
    If isActiveDirectory Then
        domainName = domain.Get("Name")
    End If
    WScript.Echo "domainName   = " & domainName
    
End Sub

'------------------------------------------------------------
' Converts binary SID into string
'------------------------------------------------------------
' Structure of an SID is as follows: 
'   1 1 1 1 1 1 
'   5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 
' +---------------------------------+ 
' | SubAuthCount   |Re(SBZ)|  Rev   | 
' +---------------------------------+ 
' |     IdentifierAuthority[0]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[1]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[2]      | 
' +---------------------------------+ 
' |                                 | 
' + -  -  -  SubAuthority[]  -  - - + 
' |                                 | 
' +---------------------------------+
Function ConvertSidToString(sid) 
    revision = Ascb(Midb(sid, 1, 1))
    subAuthCount = CInt(Ascb(Midb(sid, 2, 1)))

    Dim sidauth(5)
    For i = 0 To 5
        sidauth(i) = Ascb(Midb(sid, 3+i, 1))
    Next
    If ( (sidauth(0) <> 0) OR (sidauth(1) <> 0) ) Then
        authority = "0x"
        For i = 0 To 5 
            authority = authority & Right("0" & Hex(Ascb(sidauth(i))), 1)
        Next       
       
    Else
        authority = CLng(sidauth(2)*(256^3) + sidauth(3)*(256^3) _
                         + sidauth(4)*(256^1) + sidauth(5))
    End If

    strSid = "S-" & revision & "-" & authority 
    c = 9
    For i = 1 To subAuthCount
        auth = 0
        For j = 0 To 3
            auth = auth + CLng(Ascb(Midb(sid,c,1)))*(256^j)
            c = c + 1
        Next
        strSid = strSid & "-" & cstr(auth)
    Next
    ConvertSidToString = strSid
End Function


